<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

class ReportController extends JController
{
	function __construct($config = array())
	{
		parent::__construct($config);
		$this->registerTask( 'add',  'edit' );
		$this->registerTask( 'apply', 'save' );
	}

	function display( )
	{
		parent::display();
	}
	function edit()
	{
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar( 'view', 'report'  );
		parent::display();
	}

	function save()
	{
		global $mainframe;
		$user = JFactory::getUser();
		$model	=& $this->getModel();
		$row = JTable::getInstance("report", 'Report');
		$vals = array();
		$task = JRequest::getVar('task');
		$vals['id'] = JRequest::getInt('id');
		$vals['params'] = JRequest::getVar('params');
		$vals['access'] = JRequest::getInt('access');
		$vals['published'] = JRequest::getInt('published');
		$vals['ordering'] = JRequest::getInt('ordering');
		$vals['name'] = JRequest::getVar('title');
		$vals['params']['type'] = JRequest::getVar('type');
		$registry = new JRegistry();
		$registry->loadArray($vals['params']);
		$vals['params'] = $registry->toString();
		$vals['checked_out'] = $user->id;
		$vals['checked_out_time'] = date("Y:m:d H:i:s");
		$vals['catid'] = JRequest::getInt('catid');

		if (!$row->bind( $vals ))
		{
			JError::raiseWarning(500, $row->getError());
		}
		if (!$row->id) {
			$row->ordering = $row->getNextOrder(  );
		}

		if (!$row->check())
		{
			JError::raiseWarning(500, $row->getError());
		}
		if (!$row->store())
		{
			JError::raiseWarning(500, $row->getError());
		}
		if($task == 'save') $row->checkin($vals['id']);

		if( $task == 'apply'){
			$link = 'index.php?option=com_analytics&view=report&task=edit&cid[]='.$row->id;
		}else{
			$link = 'index.php?option=com_analytics';
		}
		$mainframe->redirect($link, JText::_('Report is saved successfully') );
	}

	function saveorder()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('report');
		$model->saveorder($cid, $order);

		$msg = JText::_('New ordering saved');
		$this->setRedirect( 'index.php?option=com_analytics', $msg );
	}

	function publish()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$model = $this->getModel('report');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_analytics' );
	}

	function unpublish()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unpublish' ) );
		}

		$model = $this->getModel('report');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_analytics' );
	}

	function cancel()
	{
		global $mainframe;
		$row = JTable::getInstance("report", 'Report');
		$row->checkin(JRequest::getInt('id'));
		$this->setRedirect( 'index.php?option=com_analytics' );

	}
	
	function accesspublic() {
		$this->changeAccess ( 0 );
	}
	function accessregistered() {
		$this->changeAccess ( 1 );
	}
	function accessspecial() {
		$this->changeAccess ( 2 );
	}

	function changeAccess( $access ) {
		global $mainframe;
		$cid = JRequest::getVar ( 'cid', array (0 ), 'post', 'array' );
		$model = $this->getModel('report');
		$model->changeAccess ( $cid [0], $access );
		$mainframe->redirect ( 'index.php?option=com_analytics' );
	}
	
	function remove()
	{
		global $mainframe;

		JRequest::setVar('view', 'report');

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$db = & JFactory::getDBO();
		$ids = implode(",", $cid);

		if (count( $ids ) < 1) {
			JError::raiseError(500, JText::_( 'Select reports to remove' ) );
		}

		$sql = "DELETE FROM #__me_analytics WHERE id IN ($ids)";
		$db->setQuery($sql);
		$db->query();

		$this->setRedirect( 'index.php?option=com_analytics' );
		parent::display();
	}
	
}