<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class ReportViewReport extends JView
{
	function display($tpl = null)
	{
		if($this->getLayout() == 'form'){
			$this->_form($tpl);
			return;
		}

		global $mainframe, $option;

		JToolBarHelper::preferences('com_analytics', '206', '570', JText::_('Configurations'));
		
		$db		=& JFactory::getDBO();
		$uri	=& JFactory::getURI();

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'filter_state',		'filter_state',	'',	'word' );
		$filter_catid		= $mainframe->getUserStateFromRequest( $option.'filter_catid',		'filter_catid',		0,				'int' );
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering', 'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'DESC',     'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',			'string' );
		$search				= JString::strtolower( $search );

		// Get data from the model
		$items		= & $this->get('Data');
		$total		= & $this->get('Total');
		$pagination = & $this->get('Pagination');

		$lists['state'] = JHTML::_('grid.state', $filter_state, 'Published', 'Unpublished');
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		$lists['search']= $search;
		// build list of categories
		$javascript 	= 'onchange="document.adminForm.submit();"';
		$lists['catid'] = JHTML::_('list.category',  'filter_catid', 'com_analytics', intval( $filter_catid ), $javascript );

		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('lists',		$lists);
		$this->assignRef('items',		$items);
		$this->assignRef('pagination',	$pagination);

		parent::display($tpl);
	}
	function _form($tpl)
	{
		global $mainframe, $option;
		$document = & JFactory::getDocument();
		$document->addScript( JURI::root().'administrator/components/com_analytics/js/analytics.js' );

		$model	=& $this->getModel();
		$user = & JFactory::getUser();

		$report = $model->getReport();
		$params = new JParameter($report->params, JPATH_COMPONENT_ADMINISTRATOR.DS.'params.xml');
		$slider = JPane::getInstance('Sliders');
		$isNew = $report->id == 0;

		if ($model->isCheckedOut( $report, $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( 'The Report' ), $type->name );
			$mainframe->redirect( 'index.php?option='. $option, $msg );
		}
		$report_params = false;

		if (!$isNew)
		{
			$model->checkout( $user->get('id') );				
			$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');

		}
		else
		{
			$report->published = 1;
		}

		JToolBarHelper::title(   $isNew ? JText::_( 'New Report' ) : JText::_( 'Edit Report' ), 'generic.png' );
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}

		$plugins = $model->getGroupsOptions();
		$lists['types'] = JHTML::_('select.genericlist',  $plugins, 'type', 'class="inputbox" onchange="xajax_reportTypeParams(this.value);"', 'value', 'text', $params->get('type'));

		$lists['published'] = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $report->published );

		$lists['access']  = JHTML::_('list.accesslevel', $report );
		
		$lists['catid']  = JHTML::_('list.category',  'catid', 'com_analytics', intval( $report->catid ) );

		// build the html select list for ordering
		$query = 'SELECT ordering AS value, name AS text'
		. ' FROM #__me_analytics'
		. ' ORDER BY ordering';
		$lists['order'] 			= JHTML::_('list.specificordering',  $report, $report->id, $query, 1 );


		$this->assignRef('isNew',	$isNew);
		$this->assignRef('report',	$report);
		$this->assignRef('params',	$params);
		$this->assignRef('report_params',	$report_params);
		$this->assignRef('slider',	$slider);
		$this->assignRef('lists',	$lists);

		parent::display($tpl);
	}
}