<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

require_once(dirname(__FILE__) . "/amChart.php");

/**
 * Class to create a pie chart from the amCharts library.
 */
class AmPieChart extends AmChart {

	var $slices = array();
	var $defaultConfig = array();

	/**
	 * @see AmChart::getSwfPath()
	 */
	function getSwfPath() {
		return parent::getLibraryPath(). "ampie/ampie.swf";
	}
	
	/**
	 * Adds a new slice to the pie chart.
	 *
	 * @param	string				$_id
	 * @param	string				$_title
	 * @param	mixed				$_value
	 * @param	array				$_config
	 */
	function addSlice( $_title, $_value, $_config = array()) {

		$this->slices[] = array(
			"title" => $_title,
			"value" => $_value,
			"config" => $_config
		);

	}

	/**
	 * Sets the default config for slices.
	 *
	 * @param	array				$_config
	 */
	function setDefaultConfig($_config) {
		//$this->defaultConfig = $_config;   setup it in general file
	}

	/**
	 * @see AmChart::getDataXml()
	 */
	function getDataXml($_asString = true) {

		$chart = new JSimpleXMLElement('pie');
		/*
		 * Slices
		 */
		foreach($this->slices AS $id => $slice) {

			$sliceNode = &$chart->addChild("slice");
			$sliceNode->setData( addslashes(str_replace('"',"'", $slice['value'])) );
			$sliceNode->addAttribute("title", addslashes(str_replace('"',"'", $slice['title'])));

			// Config

			$allAttributes = array_merge($this->defaultConfig, $slice['config']);

			foreach($allAttributes AS $key => $value) {
				$sliceNode->addAttribute($key, addslashes(str_replace('"',"'", $value)));
			}
		}
		/*
		 * Return
		 */
		if($_asString) {
//			var_dump($chart->toString(false));
			return $chart->toString(false);
		}
		else
			return $chart;

	}

}

?>