<?php
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

class ReportModelReport extends JModel
{
	var $_data = null;
	var $_id = null;

	function __construct()
	{
		parent::__construct();

		global $mainframe, $option;

		// Get the pagination request variables
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );

		// In case limit has been changed, adjust limitstart accordingly
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}
	function setId($id)
	{
		// Set weblink id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	function getCategories($ids = false)
	{
		$user = JFactory::getUser();
		if ( $ids && is_array($ids) )
			$ids = implode(', ', $ids);
		$sql = "SELECT title, id, alias, image, description
			FROM #__categories WHERE published = '1' AND section = 'com_analytics' AND access <= {$user->aid}";
		if( $ids ) 
			$sql .= " AND id IN ( $ids )";
		$sql .= " ORDER BY ordering";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}
	
	/**
	 * Return categories object(s)
	 * 
	 * @param $cat categories ids
	 * @param $rid allowed reports ids, if not set return all
	 * 
	 * @return array ObjectList
	 */

	function getReportsByCategoryIds($cat, $rid = false)
	{		
		if ( $rid && is_array($rid) )
			$rid = implode(', ', $rid);
		$where = $this->_buildContentWhere($cat, $rid);
		$sql = "SELECT * FROM #__me_analytics r";
		$sql .= $where;
		$sql .= " ORDER BY r.ordering";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}
	
	/**
	 * Return categories ids 
	 * 
	 * @param $rid allowed reports ids,if not set return all
	 * 
	 * @return array
	 */
	
	function getCategoriesIdsByReportsIds($rid = false)
	{
		$sql = "SELECT DISTINCT catid FROM #__me_analytics ";
		if ( $rid ) 
			$sql .= " WHERE id IN ($rid)";
		$sql .= " GROUP BY catid";
		$this->_db->setQuery($sql);
		return $this->_db->loadResultArray();
	}

	function _buildContentWhere($cat, $rid)
	{
		global $mainframe, $option;

		$user = JFactory::getUser();
		$access = (int) $user->get('aid', 0);

		$search       = $mainframe->getUserStateFromRequest( $option.'search',       'search',       '',         'string' );
		$search       = JString::strtolower( $search );
		$where = array();

		$where[] = "r.published = '1' AND r.access <= {$access}";//" AND cc.published = '1' AND cc.access <= {$access}";

		if( $cat )
			$where[] = "r.catid IN (".(is_array($cat) ? implode(", ", $cat) : $cat).")";

		if ( $rid )
			$where[] = "r.id IN ( $rid )";


		if ( $search ) {
			$where[] = 'LOWER(r.name) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );
		}

		$where = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}
}
