<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class ReportViewReport extends JView
{
	function display($tpl = null)
	{
		global $mainframe;
		
		$id = JRequest::getInt('id');
		if( !$id ) {
			$error = JText::_('Report is not selected');
		}else {

			$title = JText::_('Reports');
			$model	=& $this->getModel();
			
			$report = JTable::getInstance('Report', 'Report');
			$report->load($id);
						
			$pathway    = & $mainframe->getPathway();
			$pathway->addItem( JText::_($report->name), 'index.php?option=com_analytics' );
			
			$document	= &JFactory::getDocument();
			$document->addScript( JURI::root().'components/com_analytics/js/swfobject.js' );
	
			$user = JFactory::getUser();
			$params = new JParameter($report->params);
			$groups = $params->get('groups');
			$mparams = clone($mainframe->getParams('com_analytics'));
	
			$error = '';
			$access = true;
			switch($report->access)
			{
				case '1':
					if(!$user->id )
					{
						$error = JText::_('You have to log in to access this report');
						$access = false;
					}
					break;
				case '2':
					$access = true;
					if($user->get('aid', 0) < $report->access )
					{
						$error = JText::_("You don't have enough rights to access this report");
						$access = false;
					}
					break;
				default: break;
			}
			if($groups && !is_array($groups)) settype($groups, 'array');
			if( $groups && 
				!(
				    ( $user->id == 62 ) ||
					(in_array($user->gid, $groups)) || 
					(!$user->id && in_array(29, $groups)) || 
					(in_array(30, $groups) && in_array($user->gid, array(23, 24, 25)))
				)
			)
			{
				$error = JText::_("You don't have rights to access this report");
				$access = false;
			}
	
			if($params->get('user_stick') && !$user->id)
			{
				$error = JText::_("You don't have rights to access this report. You must log in first");
				$access = false;
			}
			
			$limit = JRequest::getInt('limit');
			if($pparams = JRequest::getVar('params'))
			{
				$params->set('sort_by', (isset($pparams['sort_by']) ? $pparams['sort_by']: 0));
				$limit = isset($pparams['limit']) ? $pparams['limit'] : 0;
			}
			$groupby = isset($pparams['groupby']) ? $pparams['groupby'] : 0;
			$params->set('limit', $limit);
			$params->set('groupby', $groupby);
			
			$show_userlist = $mparams->get('show_userlist', 0);
			$skin_url = JURI::root().'components/com_analytics/skins/'. $mparams->get('skin', 'default');
			$skin_path = JPATH_COMPONENT.DS.'skins'.DS.$mparams->get('skin', 'default');
			
			if( $show_userlist )
				$users = JHTML::_('list.users',  'user_id', JRequest::getInt('user_id', ($params->get('user_stick') ? $user->id : 0)), 1, null, 'name', 0 );
	
			$report->params = $params->toString();
			
			$cat = $model->getCategories($report->catid);
			$report->category = $cat[0]->title;
	
			$this->assignRef('show_userlist',	$show_userlist);
			$this->assignRef('report',	$report);
			$this->assignRef('userlist',	$users);
			$this->assignRef('user',	$user);
			$this->assignRef('access',	$access);
			$this->assignRef('skin_url',	$skin_url);
			$this->assignRef('skin_path',	$skin_path);
			$this->assignRef('id',	$id);
		}
		
		$this->assignRef('error',	$error);
		
		parent::display($tpl);
	}
}